'**************************************************************
' SCORE.BAS = Highscore-Liste direkt in QB-EXE-Datei einbetten
' =========
' Dieses Q(uick)Basic-Programm demonstriert, wie man eine
' Highscore-Liste direkt in die EXE-Datei eines Spielprogramms
' einbettet. Das Programm beinhaltet die Funktionen Highscore-
' Liste verschluesseln,schreiben,entschluesseln, sortieren,
' anzeigen, um Hoechstwert ergaenzen...
'
'(c) 2003 written by Sebastian 'qstyle' Ervens
'    exklusiv fuer www.q-basic.de |
'**************************************************************
'
DECLARE FUNCTION stXor$ (zKette$)
DECLARE FUNCTION lXor& (Zahl&)
DECLARE SUB ZeigScores ()
DECLARE SUB Lese ()
DECLARE SUB NeuScore ()
DECLARE SUB Schreibe ()
'
CONST Max = 10
CONST File$ = "SCORE.EXE"
'
' Tip: Eine total coole Routine von Pawel
' (EXEPATH.BAS, gibt es in der QBMonsterFAQ.
'
' Dann macht es auch nichts wenn die EXE Datei
' umbenannt wird. Schau es dir an und bau es selber ein!
'
DIM SHARED Signatur AS LONG
'
' Erkennungssignatur ob Scores schon
' in EXE gespeichert.
Signatur = &HABCDEF01
'
TYPE einScore
pName AS STRING * 16
pScore AS LONG
END TYPE
'
DIM SHARED p(Max + 1) AS einScore
DIM SHARED blockGr%
'
' Wir benoetigen die genaue Groee der
' Highscoreliste in Bytes.
blockGr% = LEN(p(1)) * Max + LEN(Signatur)
'
' Standart Scores einlesen
RESTORE Standard
FOR i% = 1 TO Max
READ p(i%).pName
READ p(i%).pScore
NEXT i%
DO
CLS
PRINT "Was moechtest du?"
PRINT "1) Scores schreiben"
PRINT "2) Scores lesen"
PRINT "3) Neuen (hoechsten) Score setzen"
PRINT "4) Scores anzeigen"
PRINT "5) ENDE"
Taste$ = INPUT$(1)
SELECT CASE Taste$
CASE "1": Schreibe
CASE "2": Lese
CASE "3": NeuScore: Schreibe
CASE "4": ZeigScores: Dummy$ = INPUT$(1)
CASE "5": CLOSE : END
END SELECT
LOOP UNTIL Taste$ = "5"
END
Standard:
DATA Seb,1000,Mikel,2000,DTC,3000,Sven,4000,Ilona,5000
DATA Karl, 6000, Guenter, 7000, Magnus, 8000, Richard, 9000
DATA Carlos, 10000

'
SUB Lese
CLOSE #1
OPEN File$ FOR BINARY AS #1
IF LOF(1) = 0 THEN
PRINT "Datei "; File$; " nicht gefunden. Programmabbruch."
CLOSE #1
KILL File$
END
END IF
dl& = LOF(1)
ep& = dl& - blockGr%
GET #1, ep&, Kennung&
IF Kennung& = Signatur& THEN
SEEK #1, ep& + 5
FOR i% = 1 TO Max
GET #1, , p(i%).pName
GET #1, , p(i%).pScore
tpName$ = stXor$(p(i%).pName)
tpScore& = lXor&(p(i%).pScore)
p(i%).pName = tpName$
p(i%).pScore = tpScore&
NEXT i%
ELSE
PRINT "Invalide Signatur. Womoeglich wurden"
PRINT "noch keine Scores in "; File$; " gespeichert"
CLOSE
Dummy$ = INPUT$(1)
END IF
END SUB

'
' Zahl kodieren
FUNCTION lXor& (Zahl&)
lXor& = Zahl& XOR 255
END FUNCTION

'
SUB NeuScore
LINE INPUT "Spielername :", ns$
p(Max + 1).pName = ns$
LINE INPUT "Spielerscore:", ns$
ns& = VAL(ns$)
p(Max + 1).pScore = ns&
END SUB

'
SUB Schreibe
CLOSE #1
OPEN File$ FOR BINARY AS #1
IF LOF(1) = 0 THEN
PRINT "Datei "; File$; " nicht gefunden. Programmabbruch."
CLOSE #1
KILL File$
END
END IF
'Sortieren
FOR i% = 1 TO Max + 1
FOR j% = i% TO Max + 1
IF p(i%).pScore <= p(j%).pScore THEN
SWAP p(i%), p(j%)
END IF
NEXT j%
NEXT i%
'
dl& = LOF(1)
ep& = dl& - blockGr%
GET #1, ep& + 1, Kennung&
'
' Score schon enthalten also ueberschreiben
IF Kennung& = Signatur& THEN
SEEK #1, ep& + 5
FOR i% = 1 TO Max
tpName$ = stXor$(p(i%).pName)
tpScore& = lXor&(p(i%).pScore)
PUT #1, , tpName$
PUT #1, , tpScore&
NEXT i%
ELSE
'Hat noch keine Scores im EXE File
PUT #1, dl&, Signatur&
SEEK #1, dl& + 5
FOR i% = 1 TO Max
tpName$ = stXor$(p(i%).pName)
tpScore& = lXor&(p(i%).pScore)
PUT #1, , tpName$
PUT #1, , tpScore&
NEXT i%
END IF
END SUB

'
'String kodieren
FUNCTION stXor$ (zKette$)
temp$ = SPACE$(LEN(zKette$))
FOR n% = 1 TO LEN(zKette$)
MID$(temp$, n%, 1) = CHR$(ASC(MID$(zKette$, n%, 1)) XOR 255 - n%)
NEXT n%
stXor$ = temp$
END FUNCTION

'
'Scores anzeigen
SUB ZeigScores
PRINT
FOR i% = 1 TO Max
PRINT p(i%).pName; p(i%).pScore
NEXT i%
END SUB

